# PathFinder.py

from ev3robot import *

robot = LegoRobot()
gear = Gear()
robot.addPart(gear)
ls_left = LightSensor(SensorPort.S1)
robot.addPart(ls_left)
ls_right = LightSensor(SensorPort.S2)
robot.addPart(ls_right)
gear.setSpeed(20)
gear.forward()

while robot.isConnected():
    leftValue = ls_left.getValue()
    rightValue = ls_right.getValue()
    d = rightValue - leftValue
    if d > 100: # left dark , turn right
        gear.rightArc(0.1)
    if d < -100: # right dark, turn left
        gear.leftArc(0.1)
    if d > -100 and d < 100:
        if leftValue > 450:  # both bright (on path)
          gear.forward()
        else:
          gear.backward()   # both dark (off path)
robot.exit()
