# Robo2c.py

from simrobot import *
#from nxtrobot import *
#from ev3robot import *

RobotContext.useObstacle("sprites/bg.gif", 250, 250)
RobotContext.setStartPosition(310, 470)

tMove = 5000
tTurn = 580

def createGUI():    
   frame = JFrame("Controller")
   p = JPanel()
   p.setPreferredSize(Dimension(200, 80))
   for button in buttons:   
      p.add(button)
      button.setPreferredSize(Dimension(80, 30))
   frame.add(p)
   frame.pack()
   frame.setLocation(600, 40)
   frame.setVisible(True)

def actionCallback(e):
   global state
   button = e.getSource()  
   if button == buttons[0]:
      state = State.LEFT
   elif button == buttons[1]:
      state = State.RIGHT
   elif button == buttons[2]:
      state = State.RUN
   elif button == buttons[3]:
      print "Brainwash"
      del memory[:]
      print "Memory = " + str(memory)
      
buttons = [
  JButton("Left", actionListener = actionCallback),
  JButton("Right", actionListener = actionCallback),
  JButton("Run", actionListener = actionCallback),
  JButton("Forget", actionListener = actionCallback)]

createGUI()
memory = []
State = enum("STOPPED", "FORWARD", "LEFT", "RIGHT", "RUN")
state = State.FORWARD

robot = LegoRobot()
gear = Gear()
gear.setSpeed(50)
robot.addPart(gear)
print "Learning now..."

while robot.isConnected():
   if state == State.FORWARD:
      gear.forward(tMove)
      state = State.STOPPED
   elif state == State.LEFT:
      memory.append(0)
      print "Memory = " + str(memory)
      gear.left(tTurn)
      gear.forward(tMove)
      state = State.STOPPED
   elif state == State.RIGHT:
      memory.append(1)
      print "Memory = " + str(memory)
      gear.right(tTurn)
      gear.forward(tMove)
      state = State.STOPPED
   elif state == State.RUN:
      print "Executing now..."
      robot.reset()
      print "Moving forward",
      gear.forward(tMove)
      for k in memory:
         if k == 0:
            print "- Turning left"
            gear.left(tTurn)
         else:        
            print "- Turning right"
            gear.right(tTurn)
         print "Moving forward"
         gear.forward(tMove)
      gear.stop()  
      print "All done."
      state = State.STOPPED
robot.exit()
