# ArduinoLink.py

from LegoRobot import LegoRobot
from Sensor import Sensor

class ArduinoLink(Sensor):
    def __init__(self, port):
        Sensor.__init__(self, port)
        self.partName = "arl" + str(port.getId() + 1)
    
    def init(self):
       LegoRobot.showDebug("ArduinoLink.init() called")
 
    def cleanup(self):
        LegoRobot.showDebug("ArduinoLink.cleanup() called")

    def getReplyInt(self, request):
        v = int(self.robot.sendCommand(self.partName + ".getReplyInt." + str(request)))
        return v
        
    def getReply(self, request, reply):
        value = self.robot.sendCommand(self.partName + ".getReplyArduino." + str(request))
        data = value.split(":")
        for i in range(16):
            reply[i] = int(data[i])

    def getReplyString(self, request):
        reply = [0] * 16
        self.getReply(request, reply)
        s = ""
        for i in range(16):  
           if reply[i] > 0 and reply[i] < 256:  # only valid ASCII bytes
                s += unichr(reply[i])
           if reply[i] == 0: # terminate at C null terminator
               break
        return s 


        
    
  
 

