# GenericIRSensor.py

from LegoRobot import LegoRobot
from Sensor import Sensor

class IRValue():
    def __init__(self):
        self.channel = 1
        self.bearing = 0
        self.distance = 255

class SensorMode():
    SEEK_MODE = 0
    DISTANCE_MODE = 1 

class GenericIRSensor(Sensor):
    def __init__(self, port, mode):
        Sensor.__init__(self, port)
     
    def init(self):
        LegoRobot.showDebug("DEBUG: GenericIRSensor.init() called")

    def cleanup(self):
        LegoRobot.showDebug("DEBUG: GenericIRSensor.cleanup() called")

    def toIRValue(self, value):
        irValue = IRValue()
        irValue.channel = self.getPort().getId() + 1
        irValue.bearing = (value & 0xFF) - 64
        irValue.distance = (value >> 8) & 0xFF
        return irValue

    def getIntValue(self):
        v = int(self.robot.sendCommand(self.partName + ".getIntValue"))
        return v
        
    def getValue(self):
        return self.toIRValue(self.getIntValue())
 