# HTColorSensor.py

from LegoRobot import LegoRobot
from Color import Color
from Sensor import Sensor

class HTColorSensor(Sensor):
    def __init__(self, port):
        Sensor.__init__(self, port)
        self.partName = "htcs" + str(port.getId() + 1)
    
    def init(self):
       LegoRobot.showDebug("HTColorSensor.init() called")
 
    def cleanup(self):
        LegoRobot.showDebug("HTColorSensor.cleanup() called")

    def getColorInt(self):
        v = int(self.robot.sendCommand(self.partName + ".getColorInt"))
        return v
        
    def getColorID(self):
        v = int(self.robot.sendCommand(self.partName + ".getColorID"))
        return v

    def getColor(self):
        return Color(self.getColorInt())  
  
    def setFloodlight(self, colorValue):
        self.robot.sendCommand(self.partName + ".setFloodlight." + str(colorValue))

    @staticmethod  
    def inColorCube(color, colorCube):
        if (color.getRed() >= colorCube[0] and color.getRed() <= colorCube[1]
           and color.getGreen() >= colorCube[2] and color.getGreen() <= colorCube[3]
           and color.getBlue() >= colorCube[4] and color.getBlue() <= colorCube[5]):
            return True
        return False
  