# HTCompassSensor.py

from LegoRobot import LegoRobot
from Sensor import Sensor

class HTCompassSensor(Sensor):
    def __init__(self, port):
        Sensor.__init__(self, port)
        self.partName = "htcp" + str(port.getId() + 1)
        self.isCalibrating = False
    
    def init(self):
       LegoRobot.showDebug("HTCompassSensor.init() called")
 
    def cleanup(self):
        LegoRobot.showDebug("HTCompassSensor.cleanup() called")

    def getValue(self):
        v = int(self.robot.sendCommand(self.partName + ".getValue"))
        return v
        
    def startCalibration(self):    
        if self.isCalibrating:
            return
        self.isCalibrating = True
        self.robot.sendCommand(self.partName + ".startCalibration");
        

    def stopCalibration(self):    
        if not self.isCalibrating:
            return
        self.isCalibrating = False
        self.robot.sendCommand(self.partName + ".stoptCalibration");
    
  
 

