# PrototypeSensor.py

from LegoRobot import LegoRobot
from Sensor import Sensor

class PrototypeSensor(Sensor):
    def __init__(self, port):
        Sensor.__init__(self, port)
        self.partName = "pts" + str(port.getId() + 1)
    
    def init(self):
       LegoRobot.showDebug("Prototype.init() called")
 
    def cleanup(self):
        LegoRobot.showDebug("Prototype.cleanup() called")

    def setDIOMask(self, mask):
        self.robot.sendCommand(self.partName + ".setDIOMask." + str(mask))
        
    def readAnalog(self, ain):
        din = [0] * 6
        self.read(ain, din)

    def readDigital(self, din):
        ain = [0] * 5
        self.read(ain, din)

    def read(self, ain, din):
        value = self.robot.sendCommand(self.partName + ".readSuperPro")
        data = value.split(":")   # an0:an1:an2:an3:dig
        for i in range(5):
            ain[i] = int(data[i])

        v = int(data[5])
        power = 1
        for i in range(6):
            if v & power == 0:
                din[i] = 0
            else:
                din[i] = 1
            power *= 2;

    def writeByte(self, value):
        self.robot.sendCommand(self.partName + ".writeByte." + str(value))
        
    def setSamplingPeriod(self, period):
        self.robot.sendCommand(self.partName + ".setSamplingPeriod." + str(period))
  
    def getProductID(self):
        v = self.robot.sendCommand(self.partName + ".getProductID")
        return v
     
    def getVersion(self):
        v = self.robot.sendCommand(self.partName + ".getVersion")
        return v
     

