# RFIDSensor.py

from LegoRobot import LegoRobot
from Sensor import Sensor

class RFIDSensor(Sensor):
    def __init__(self, port):
        Sensor.__init__(self, port)
        self.partName = "rfid" + str(port.getId() + 1)
    
    def init(self):
       LegoRobot.showDebug("RFIDSensor.init() called")
 
    def cleanup(self):
        LegoRobot.showDebug("RFIDSensor.cleanup() called")
        
    def getProductID(self): 
        v = int(self.robot.sendCommand(self.partName + ".getProductID"))
        return v

    def getVersion(self): 
        v = int(self.robot.sendCommand(self.partName + ".getVersion"))
        return v

    def setContMode(self, continuous):
        if continuous:
            self.robot.sendCommand(self.partName + ".setContMode.b1")
        else:
            self.robot.sendCommand(self.partName + ".setContMode.b0")

    def getTransponderId(self): 
        v = long(self.robot.sendCommand(self.partName + ".getTransponderId"))
        return v

 

