# UltrasonicSensor.py

from LegoRobot import LegoRobot
from Sensor import Sensor
from threading import Thread
from Tools import Tools

class UltrasonicSensor(Sensor, Thread):
    ultrasonicSensorPollDelay = 200  # ms
    
    def __init__(self, port, near = None, far = None):
        Sensor.__init__(self, port)
        Thread.__init__(self)
        self.partName = "us" + str(port.getId() + 1)
        self.near = near
        self.far = far
        self.sensorState = 0  # near
        self.triggerLevel = 10
    
    def init(self):
       LegoRobot.showDebug("UltrasonicSensor.init() called")
       if self.near != None or self.far != None:
           self.startThread()
 
    def cleanup(self):
        LegoRobot.showDebug("UltrasonicSensor.cleanup() called")
        self.stopThread()

    def getDistance(self):
        v = int(self.robot.sendCommand(self.partName + ".getDistance"))
        return v
        
    def setTriggerLevel(self, triggerLevel):
        self.triggerLevel = triggerLevel
        
    def startThread(self):
        self.isRunning = True
        self.start()
    
    def stopThread(self):
        self.isRunning = False
        
    def run(self):
        while self.isRunning:
            Tools.delay(UltrasonicSensor.ultrasonicSensorPollDelay)
            distance = self.getDistance();
            if self.sensorState == 0 and distance > self.triggerLevel:
                if self.far != None:
                    self.far(self.getPort(), distance)
                self.sensorState = 1
            if self.sensorState == 1 and distance <= self.triggerLevel:
                if self.near != None:
                    self.near(self.getPort(), distance)
                self.sensorState = 0
             
        
    def setMeshTriangleColor(self, color):
        pass

    def setBeamAreaColor(self,  color):
        pass

    def eraseBeamArea(self):
        pass
        
    def setProximityCircleColor(self, color):
        pass
   
    
  
 

