// Arduino1.java
// I2C communication between EV3 and Arduino

import ch.aplu.ev3.*;
import ch.aplu.util.*;

public class Arduino1 extends Console 
{
  public Arduino1()
  {
    LegoRobot robot = new LegoRobot();
    ArduinoLink arduino = new ArduinoLink(SensorPort.S1);
    robot.addPart(arduino);

    println("Arduino Connection Test");

    int[] data = new int[16];

    while (true)
    {
      println("Press key to send request...");
      int rc = getKeyCodeWait();
      if (rc == 27)  // ESC
        break;
      arduino.getReply(65, data);  // Send command 'A'
      int i;
      for (i = 0; i < 16; i++)
        if (data[i] == 0)
          break;
      System.out.println("Reply: " + new String(data, 0, i));
    }
    robot.exit();
  }

  public static void main(String[] args)
  {
    new Arduino1();
  }
}
