// Arduino2.java
// I2C communication between EV3 and Arduino

import ch.aplu.ev3.*;
import ch.aplu.util.*;

public class Arduino2 extends Console 
{
  public Arduino2()
  {
    LegoRobot robot = new LegoRobot();
    ArduinoLink arduino = new ArduinoLink(SensorPort.S1);
    robot.addPart(arduino);

    println("Arduino Connection Test");

    while (true)
    {
      println("Press key to send request...");
      int rc = getKeyCodeWait();
      if (rc == 27)  // ESC
        break;
      String reply = arduino.getReplyString(65);  // Send command 'A'
      System.out.println("Reply: " + reply);
    }
    robot.exit();
  }

  public static void main(String[] args)
  {
    new Arduino2();
  }
}
