// EV3DataLogger.java

import ch.aplu.ev3.*;
import ch.aplu.util.*;

public class EV3DataLogger
{
  public EV3DataLogger()
  {
    LegoRobot robot = new LegoRobot();
    GPanel g = new GPanel(0, 10000, 0, 1000); 
    g.title("EV3 Data Logger");
    drawGrid(g);
    NxtLightSensor ls = new NxtLightSensor(SensorPort.S1);
    robot.addPart(ls);
    int t = 0;  // time in ms
    int dt = 100; // time step in ms
    HiResAlarmTimer timer = new HiResAlarmTimer(dt);
    while (true)
    {
      while (timer.isRunning())
      {
      }  // Wait until period is over
      timer.start();
      int value = ls.getValue();
      g.title("Time: " + (t / 1000.0) + " s  Value: " + value);
      int x = t % 10000;
      if (x == 0)
      {
        drawGrid(g);
        g.move(x, value);
      }
      else
        g.draw(x, value);

      t += dt;
    }
  }

  private void drawGrid(GPanel g)
  {
    g.clear();
    for (int x = 0; x <= 10000; x += 1000)
      g.line(x, 0, x, 1000);
    for (int y = 0; y <= 1000; y += 100)
      g.line(0, y, 10000, y);
  }

  public static void main(String[] args)
  {
    new EV3DataLogger();
  }
}
