// EV3TempLogger.java

import ch.aplu.ev3.*;
import ch.aplu.util.*;

public class EV3TempLogger
{
  public EV3TempLogger()
  {
    LegoRobot robot = new LegoRobot();
    GPanel g = new GPanel(0, 1000, -30, 30); 
    g.title("EV3 Data Logger");
    drawGrid(g);
    TemperatureSensor ts = new TemperatureSensor(SensorPort.S1);
    robot.addPart(ts);
    int t = 0;  // time in s
    int dt = 1; // time step in s
    while (true)
    {
      double temp = ts.getTemperature();
      g.title("Time: " + t + " s  Temp: " + temp);
      if (t == 0)
        g.move(t, temp);
      else
        g.draw(t, temp);
      Tools.delay(1000 * dt);
      t += dt;
    }
  }

  private void drawGrid(GPanel g)
  {
    for (int x = 0; x <= 1000; x += 100)
      g.line(x, -30, x, 30);
    for (int y = -30; y <= 30; y += 10)
      g.line(0, y, 1000, y);
  }

  public static void main(String[] args)
  {
    new EV3TempLogger();
  }
}
