// IRSensor4.java

import ch.aplu.ev3.*;
import ch.aplu.turtle.*;

class IRSensor4
{
  int channel = 1;

  IRSensor4()
  {
    LegoRobot robot = new LegoRobot("10.0.1.1", false);
    boolean rc = robot.connect(false, false);
    IRRemoteSensor irr = new IRRemoteSensor(SensorPort.S1);
    robot.addPart(irr);
    Turtle t = new Turtle();
    if (rc)
      t.setTitle("Remote Control Ready");
    else
    {
      t.setTitle("Connection To Remote Control Failed");
      return;
    }

    while (true)
    {
      String cmd = irr.getCommandStr();
      switch (cmd)
      {
        case "TopLeft":
          t.forward(10);
          break;
        case "BottomLeft":
          t.left(10);
          break;
        case "TopRight":
          t.back(10);
          break;
        case "BottomRight":
          t.right(10);
          break;
        case "BottomLeft&BottomRight":
          t.fill();
          break;
        case "Centre":
          t.clear();
          t.home();
          t.st();
          break;
      }
      Tools.delay(50);
    }
  }
  
  public static void main(String[] args)
  {
    new IRSensor4();
  }
}
